
DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/sauge/code/progress/ds/stack/tststk.p,v 1.1 2001/11/17 06:33:13 sauge Exp $" NO-UNDO.

{MakeID2.i}
{stack/stack.i}

DEF VAR lResultCode   AS LOGICAL NO-UNDO.
DEF VAR cReturnCode   AS CHARACTER NO-UNDO.
DEF VAR cData         AS CHARACTER NO-UNDO.

OUTPUT TO ./teststk.data.

PUT UNFORMATTED "Running Test~n".

/* Clear the stack */

RUN TestClearStack.

/* Is the stack empty? */

RUN TestStackEmpty.

/* Push some items on the stack */

RUN TestPushStack (INPUT "1").
RUN TestPushStack (INPUT "2").
RUN TestPushStack (INPUT "3").

/* Is the stack empty? */

RUN TestStackEmpty.

/* Pop some items off the stack */

RUN TestPopStack.
RUN TestPopStack.
RUN TestPopStack.

/* Is the stack empty? */

RUN TestStackEmpty.

OUTPUT CLOSE.

/******************************************************************/
/*            Wrap around error handling and messages             */
/******************************************************************/

PROCEDURE TestStackEmpty:

  ASSIGN lResultCode = StkEmpty(INPUT "Test", OUTPUT cReturnCode).
  
  IF lResultCode THEN
    PUT UNFORMATTED "Call to StkEmpty Errored!~n".
  ELSE
    PUT UNFORMATTED "Call to StkEmpty Successful~n".
  
  IF cReturnCode = "2" THEN
    PUT UNFORMATTED "Stack Empty~n".
  ELSE
    PUT UNFORMATTED "Stack Populated~n".

END.

PROCEDURE TestPushStack:

  DEF INPUT PARAMETER pValue AS CHARACTER NO-UNDO.

  lResultCode = StkPush(INPUT "Test", INPUT pValue, OUTPUT cReturnCode).
  
  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling PushStk.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE
    PUT UNFORMATTED "No Error occurred calling PushStk.~n".

END.

PROCEDURE TestPopStack:

  DEF VAR pValue AS CHARACTER NO-UNDO.

  lResultCode = StkPop(INPUT "Test", OUTPUT pValue, OUTPUT cReturnCode).

  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling StkPop.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE DO:
    PUT UNFORMATTED "No Error occurred calling StkPop.~n".
    PUT UNFORMATTED "Value is " pValue "~n".
  END.

END.

PROCEDURE TestClearStack:

  lResultCode = StkClear(INPUT "Test", OUTPUT cReturnCode).

  IF lResultCode THEN DO:
    PUT UNFORMATTED "An Error occurred calling StkClear.~n".
    PUT UNFORMATTED "Error is: " cReturnCode "~n".
  END.
  ELSE
    PUT UNFORMATTED "No Error occurred calling StkClear.~n".

END.


